import { t } from '@opentiny/vue-locale';
import { renderless, api } from '@opentiny/vue-renderless/mini-picker/vue';
import { defineComponent, $prefix, setup } from '@opentiny/vue-common';
import PickerColumn from '@opentiny/vue-picker-column';
import { resolveComponent, withDirectives, openBlock, createElementBlock, createElementVNode, normalizeClass, renderSlot, toDisplayString, normalizeStyle, Fragment, renderList, createBlock, vShow } from 'vue';
import '@opentiny/vue-theme-mobile/mini-picker/index.css';

function _createForOfIteratorHelperLoose(r, e) {
  var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (t) return (t = t.call(r)).next.bind(t);
  if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) {
    t && (r = t);
    var o = 0;
    return function() {
      return o >= r.length ? { done: true } : { done: false, value: r[o++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0;
  }
}
function _arrayLikeToArray(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

var $constants = {
  CHILDREN_PICKER: "childrenPicker"
};
var _sfc_main = /* @__PURE__ */ defineComponent({
  name: $prefix + "MiniPicker",
  components: {
    PickerColumn
  },
  props: {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    columns: {
      type: Array,
      default: function _default2() {
        return [];
      }
    },
    visible: {
      type: Boolean,
      default: false
    },
    title: {
      type: String,
      default: ""
    },
    confirmButtonText: {
      type: String,
      default: function _default3() {
        return t("ui.miniPicker.confirm");
      }
    },
    cancelButtonText: {
      type: String,
      default: function _default4() {
        return t("ui.miniPicker.cancel");
      }
    },
    defaultIndex: {
      type: Number,
      default: 0
    },
    valueKey: {
      type: String,
      default: "text"
    },
    itemHeight: {
      type: Number,
      default: 34
    },
    visibleItemCount: {
      type: Number,
      default: 5
    },
    swipeDuration: {
      type: Number,
      default: 1e3
    }
  },
  setup: function setup$1(props, context) {
    return setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var _hoisted_1 = /* @__PURE__ */ createElementVNode(
  "div",
  {
    class: "tiny-mobile-mini-picker__mask"
  },
  null,
  -1
  /* HOISTED */
);
var _hoisted_2 = {
  class: "tiny-mobile-mini-picker__toolbar"
};
var _hoisted_3 = {
  class: "picker_action picker_title"
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_picker_column = resolveComponent("picker-column");
  return withDirectives((openBlock(), createElementBlock(
    "div",
    {
      class: "tiny-mobile-mini-picker",
      onClick: _cache[2] || (_cache[2] = function() {
        return _ctx.visibleHandle && _ctx.visibleHandle.apply(_ctx, arguments);
      })
    },
    [_hoisted_1, createElementVNode(
      "div",
      {
        class: normalizeClass(["tiny-mobile-mini-picker__content", _ctx.state.toggle ? "is-toggle" : ""])
      },
      [createElementVNode("div", _hoisted_2, [renderSlot(_ctx.$slots, "toolbar", {}, function() {
        return [createElementVNode(
          "div",
          {
            class: "picker_action picker_cancel",
            onClick: _cache[0] || (_cache[0] = function() {
              return _ctx.cancel && _ctx.cancel.apply(_ctx, arguments);
            })
          },
          toDisplayString(_ctx.cancelButtonText),
          1
          /* TEXT */
        ), createElementVNode(
          "div",
          _hoisted_3,
          toDisplayString(_ctx.title),
          1
          /* TEXT */
        ), createElementVNode(
          "div",
          {
            class: "picker_action picker_confirm",
            onClick: _cache[1] || (_cache[1] = function() {
              return _ctx.confirm && _ctx.confirm.apply(_ctx, arguments);
            })
          },
          toDisplayString(_ctx.confirmButtonText),
          1
          /* TEXT */
        )];
      })]), createElementVNode(
        "div",
        {
          class: "tiny-mobile-mini-picker__columns",
          style: normalizeStyle({
            height: _ctx.state.clumnsWrapHeight + "px"
          })
        },
        [(openBlock(true), createElementBlock(
          Fragment,
          null,
          renderList(_ctx.state.formattedColumns, function(item, index) {
            return openBlock(), createBlock(_component_picker_column, {
              "columns-item": item,
              ref_for: true,
              ref: "childrenPicker" + index,
              key: index,
              "default-index": item.defaultIndex || +_ctx.state.defaultIndex,
              "item-height": _ctx.itemHeight,
              "swipe-duration": _ctx.swipeDuration,
              "value-key": _ctx.valueKey,
              onChange: function onChange($event) {
                return _ctx.change(index);
              },
              "visible-item-count": _ctx.visibleItemCount
            }, null, 8, ["columns-item", "default-index", "item-height", "swipe-duration", "value-key", "onChange", "visible-item-count"]);
          }),
          128
          /* KEYED_FRAGMENT */
        ))],
        4
        /* STYLE */
      )],
      2
      /* CLASS */
    )],
    512
    /* NEED_PATCH */
  )), [[vShow, _ctx.visible]]);
}
var MiniPicker = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
var version = "3.21.0";
MiniPicker.install = function(Vue) {
  Vue.component(MiniPicker.name, MiniPicker);
};
MiniPicker.version = version;

export { MiniPicker as default };
